<template>
  <div>
    <h1 class="text-center text-4xl">
      Gestion
      {{
        $route.name === "roadtrips"
          ? "de vos road trips"
          : $route.name === "roadtrips-admin"
          ? "de tous les road trips"
          : roadtripsGestion.selectedUser
          ? "des road trips de " +
            roadtripsGestion.selectedUser.firstname +
            " " +
            roadtripsGestion.selectedUser.lastname
          : "des road trips d'un utilisateur inconnu"
      }}
    </h1>

    <div>

      <div class="w-full md:w-1/5 mx-auto mt-4">
        <router-link
          :to="{ name: 'roadtrips-admin' }"
          v-if="user.hasRole(['ADMIN','SUPER_ADMIN'])"
          v-show="!roadtripsGestion.isAdminMode"
          class="w-24"
        >
          <Button label="Rejoindre le dashboard admin" />
        </router-link>
        <router-link
          :to="{ name: 'roadtrips' }"
          v-if="user.hasRole(['ADMIN','SUPER_ADMIN'])"
          v-show="roadtripsGestion.isAdminMode"
        >
          <Button label="Rejoindre votre dashboard" />
        </router-link>
      </div>

      <div
        v-show="roadtripsGestion.isAdminMode"
        class="w-full md:w-1/3 mx-auto my-4 text-center"
      >
        <label> Filtrer par utilisateur </label>
        <br>
        <input class="appearance-none rounded-lg w-full py-3 border border-gray-300 placeholder-gray-300 text-gray-900 focus:outline-none focus:ring-yellow-500 focus:border-yellow-500 focus:z-10 sm:text-sm" type="text" placeholder="Ex: Yves Skrzypczyk" v-model="roadtripsGestion.userSearch">
        <router-link
            :to="{ name: 'roadtrips-admin' }"
            v-show="roadtripsGestion.isOtherUser"
            class="w-24"
        >
          <Button label="Tout les utilisateurs" />
        </router-link>
        <ul v-if="roadtripsGestion.foundUsers" class="bg-white w-1/3 absolute z-50 right-1/3">
          <li  class="py-2" v-show="roadtripsGestion.foundUsers.length === 0">Aucun utilisateur trouvé</li>
          <li
              @click="roadtripsGestion.selectUser(user.id)"
              class="py-2"
              v-for="user in roadtripsGestion.foundUsers"
              :key="user.id"
          >
            <div class="cursor-pointer hover:bg-gray-300">
              {{user.firstname}} {{user.lastname}} ({{user.email}})
            </div>
          </li>
        </ul>
      </div>

      <div v-if="roadtripsGestion.roadTrips !== null">
        <p v-show="roadtripsGestion.roadTrips.length === 0" class="text-center">
          Aucun road trip trouvé
        </p>
        <div
          :key="roadTrip._id"
          v-for="roadTrip in roadtripsGestion.roadTrips"
          class="py-3"
        >
          <ListRoadtrip
            :author="
              roadtripsGestion.isAdminMode &&
              roadtripsGestion.usersById &&
              roadtripsGestion.usersById[roadTrip.userId]
                ? roadtripsGestion.usersById[roadTrip.userId]
                : null
            "
            :road-trip="roadTrip.roadtrip"
            :id="roadTrip._id"
            :date="new Date(roadTrip.createdAt)"
          />
        </div>
      </div>

      <p v-show="roadtripsGestion.roadtrips === null">
        Road trips en cours de chargement ...
      </p>
    </div>
  </div>
</template>

<script>
import Button from "@/components/Button.vue";
import ListRoadtrip from "@/views/roadtripsGestions/ListRoadTrip";

export default {
  name: "GestionRoadTrips",
  components: {ListRoadtrip, Button },
  inject: ["roadtripsGestion", "user"],
};
</script>

<style scoped></style>
